VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CLogger"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private Const def_mvarFileSize As Long = 32768
Private Const def_mvarFixTime As Boolean = True

Private mvarFileName As String
Private mvarFileSize As Long
Private mvarFixTime As Boolean

'log
Public Sub log(ByVal sLogString As String)
Attribute log.VB_UserMemId = 0
Dim l As Long, bOpened As Boolean, s As String
    If Len(mvarFileName) = 0 Then Exit Sub
On Error GoTo log_err
    l = FreeFile
    Open mvarFileName For Binary As l
        bOpened = True
        Seek #l, LOF(l) + 1
        s = IIf(mvarFixTime, Now & vbTab, "") & sLogString & vbCrLf
        Put #l, , s
    Close l
    bOpened = False
    FixFileSize
    Exit Sub
log_err:
    Debug.Print Err.Number & " " & Err.Description
    Err.Clear
    If bOpened Then Close l
End Sub

'fix file size to defined
Private Sub FixFileSize()
Dim s As String, lF As Long, l As Long
    If mvarFileSize = 0 Then Exit Sub
    If Len(mvarFileName) = 0 Then Exit Sub
    On Error GoTo FFS_ERR
    If FileLen(mvarFileName) > mvarFileSize Then
        lF = FreeFile
        Open mvarFileName For Binary Lock Read Write As lF
            l = LOF(lF)
            s = Space$(mvarFileSize)
            Seek lF, l - mvarFileSize + 1
            Get lF, , s
        Close lF
        l = InStr(s, vbCrLf)
        If l > 0 Then
            s = Mid(s, l + 2)
        End If
        Kill mvarFileName
        Open mvarFileName For Binary Lock Read Write As lF
            Put #lF, , s
        Close lF
    End If
FFS_ERR:
End Sub

Public Property Let FixTime(ByVal vData As Boolean)
    mvarFixTime = vData
End Property

Public Property Get FixTime() As Boolean
    FixTime = mvarFixTime
End Property

Public Property Let FileSize(ByVal vData As Long)
    mvarFileSize = vData
    FixFileSize
End Property

Public Property Get FileSize() As Long
    FileSize = mvarFileSize
End Property

Public Property Let FileName(ByVal vData As String)
    mvarFileName = vData
End Property

Public Property Get FileName() As String
    FileName = mvarFileName
End Property

Private Sub Class_Initialize()
    mvarFileName = App.Path & IIf(Right$(App.Path, 1) = "\", "", "\") & App.EXEName & ".log"
    mvarFileSize = def_mvarFileSize
    mvarFixTime = def_mvarFixTime
End Sub
